function matrix = trimColumns(matrix, zerotol)
% trim the columns of the input matrix to equal values
%
% THIS FUNCTION IS NO USER FUNCTION.

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2012 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

%% info
% Values that are close to each other, like (1+zerotol) equals 1, are
%   trimmed to be exactly equal. Afterwards unique(matrix, 'rows') can be
%   used to obtain a simplified matrix.

% iterate over columns
for iCol = 1:size(matrix, 2)
    
    % sort the current column
    [thisCol, originalRowVector] = sort(matrix(:, iCol));
    
    % cycle through the group of equal entries
    iRow = 1;
    while iRow < size(matrix, 1)
        % get the indices that are almost equal to the first one
        filterInTol = abs(thisCol - thisCol(iRow)) < zerotol;
        
        % set the original row entries to be equal
        matrix(originalRowVector(filterInTol), iCol) = thisCol(iRow);
        
        % update the row index
        iRow = find(filterInTol, 1, 'last') + 1;
    end
    
end